
#define F_CPU 16000000UL
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

volatile double DutyCycle;
volatile double Time;
volatile uint16_t time_period;
volatile uint8_t toggle_flag;

void initialize_all()
{
	//Timer1 setup
	TCCR1A |= (1<<WGM11)|(1<<WGM10)|(1<<COM1B1);
	TCCR1B |= (1<<WGM12)|(1<<WGM13)|(1<<CS10);
	TIMSK1 |= (1<<OCIE1B)|(1<<OCIE1A);
	OCR1A=time_period;
	OCR1B=DutyCycle;
	
	time_period = 249;
	Time=0;
	
	// Configure PB2 as output
	DDRB |= (1<<DDB2);
	
	// Timer0 Setup
	TIMSK0 |= (1<<TOIE0);				// Enable Timer0 ISR
	TCCR0B |= (1<<CS02) | (1<<CS00);	// Set prescaler 1024
	OCR0A = 155;						// Timer0 ticks 
}


ISR(TIMER1_COMPA_vect)
{
	DutyCycle = abs(sin(2*3.14159*62.5*Time));
	OCR1B= 250*DutyCycle;
	
}

ISR(TIMER1_COMPB_vect)
{
	
}

ISR(TIMER0_COMPA_vect)
{
	Time = Time + 0.001;	// Time variable increments every 1ms
}

int main(void)
{
	initialize_all();
	sei();
	while (1)
	{ }
}